﻿using UnityEngine;
using HarmonyLib;
using I2.Loc;
using System.Collections.Generic;

public class UnfavorableExchange : Mod
{
    public void Start()
    {

        var language = new LanguageSourceData()
        {
            mDictionary = new Dictionary<string, TermData>
            {
                ["CraftingSub/Resources"] = new TermData() { Languages = new[] { "Resources" } }
            },
            mLanguages = new List<LanguageData> { new LanguageData() { Code = "en", Name = "English" } }
        };
        LocalizationManager.Sources.Add(language);


        SetRecipe(ItemManager.GetItemByName("Plank"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube"), ItemManager.GetItemByName("Battery") }, 4),
        }, CraftingCategory.Resources, 20, true, "Resources", 0);

        SetRecipe(ItemManager.GetItemByName("Plastic"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube"), ItemManager.GetItemByName("Battery") }, 4),
        }, CraftingCategory.Resources, 20, true, "Resources", 1);

        SetRecipe(ItemManager.GetItemByName("Scrap"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube"), ItemManager.GetItemByName("Battery") }, 10),
        }, CraftingCategory.Resources, 20, true, "Resources", 2);

        SetRecipe(ItemManager.GetItemByName("Leather"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube"), ItemManager.GetItemByName("Battery") }, 10),
        }, CraftingCategory.Resources, 5, true, "Resources", 3);

        SetRecipe(ItemManager.GetItemByName("Glass"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube"), ItemManager.GetItemByName("Battery") }, 10),
        }, CraftingCategory.Resources, 10, true, "Resources", 4);
 
        


        Log("Mod UnfavorableExchange has been loaded!");
    }

    public void OnModUnload()
    {
        Debug.Log("Mod UnfavorableExchange has been unloaded!");
    }


    public static void SetRecipe( Item_Base item, CostMultiple[] cost, CraftingCategory category = CraftingCategory.Resources, int amountToCraft = 1, bool learnedFromBeginning = false, string subCategory = null, int subCatergoryOrder = 0)
    {
        Traverse recipe = Traverse.Create(item.settings_recipe);
        recipe.Field("craftingCategory").SetValue(category);
        recipe.Field("amountToCraft").SetValue(amountToCraft);
        recipe.Field("learnedFromBeginning").SetValue(learnedFromBeginning);
        recipe.Field("subCategory").SetValue(subCategory);
        recipe.Field("subCatergoryOrder").SetValue(subCatergoryOrder);
        item.settings_recipe.NewCost = cost;
    }
}